/***************************************************************************
 * File:         glbdata.c
 * Description:  global data for HPT3xx driver
 * Copyright (c) 2000-2003 HighPoint Technologies, Inc. All rights reserved.
 ***************************************************************************/

/***************************************************************************
 *   Chip Setting
 ***************************************************************************/
ULONG setting370_50[] = {
	0x0ac1f48a, 0x0ac1f465, 0x0a81f454, 0x0a81f443, 0x0a81f442, 
	0x228082ea, 0x22808254, 0x22808242, 
	0x121882ea, 0x12148254, 0x120c8242, 0x128c8242, 0x12ac8242,
	0x12848242, 0x12848242, 0x12848242,
};

#ifdef CLOCK_66MHZ
ULONG setting370_66[] = {
	0xd029d5e,  0xd029d26,  0xc829ca6,  0xc829c84,  0xc829c62,
	0x2c829d2c, 0x2c829c66, 0x2c829c62,
	0x1c829c62, 0x1c9a9c62, 0x1c929c62, 0x1c8e9c62, 0x1c8a9c62,
	0x1c8a9c62/*0x1cae9c62*/, 0x1c869c62, 0x1c869c62,
};
ULONG setting370_75[] = {
	0x0d829f5e, 0x0d029f2e, 0x0cc29ea6, 0x0cc29e84, 0x0c829e62,
	0x2c829f2e, 0x2c829e66, 0x2c829e62,
	0x1c829d62, 0x1c9a9d62, 0x1c969d62, 0x1c929d62, 0x1c8e9d62, 
	0x1c8a9d62, 0x1c8a9d62, 0x1c869d62,
};
#endif

ULONG setting370_33[] = {
	0x06814ea7, 0x06814e93, 0x06414e53, 0x06414e42, 0x06414e31, 
	0x22406c97, 0x22406c33, 0x22406c31, 
	0x12506297, 0x124c6233, 0x12486231, 0x126c6231, 0x12446231,
	0x12446231, 0x12446231, 0x12446231,
};


/***************************************************************************
 *   Data struct for vbus layer
 ***************************************************************************/



PCommand pFreeCommands = 0;

DPC_ROUTINE PendingRoutines[MAX_PENDING_ROUTINES] = { {0,}, };
int PendingRoutinesFirst=0, PendingRoutinesLast=0;

DPC_ROUTINE IdleRoutines[MAX_IDLE_ROUTINES] = { {0,}, };
int IdleRoutinesFirst=0, IdleRoutinesLast=0;


/*
 * Virtural channel instance data structure
 */
VBus   gVBus[MAX_VBUS] = { { {0,}, }, };

PChannel  pChanStart = 0;
PVDevice   pVDevStart  = 0;
char       *pDataPool   = 0;

/*
 * Chip, channel and device data structure
 */
#define MAX_GLBDATA \
	((MAX_CHIPS + 1) *sizeof(ChipInstance) + \
	  MAX_CHANNELS*sizeof(Channel) + \
	  MAX_DEVICES*sizeof(VDevice))
		
ChipInstance gChipInstances[MAX_GLBDATA / sizeof(ChipInstance)] = { {0,}, };

/* data below will not be moved to low memory in BIOS */

void HPTLIBAPI fDeviceSendCommand(_VBUS_ARG PCommand pCmd);
void HPTLIBAPI fSingleDiskFailed(_VBUS_ARG PVDevice pVDev);

#define fRAID0SendCommand 0
#define fRAID1SendCommand 0
#define fJBODSendCommand  0
#define fRAID0MemberFailed 0
#define fRAID1MemberFailed 0
#define fJBODMemberFailed  0
#define fRAID5SendCommand 0
#define fRAID5MemberFailed 0

void (* HPTLIBAPI pfnSendCommand[])(_VBUS_ARG PCommand pCmd) = {
	fDeviceSendCommand, /* SPARE */
	fDeviceSendCommand, /* REMOVEABLE */
	fDeviceSendCommand, /* ATAPI */
	fDeviceSendCommand,
	fJBODSendCommand,
	fRAID0SendCommand,
	fRAID1SendCommand,
	0,
	fRAID5SendCommand,
};

void (* HPTLIBAPI pfnDeviceFailed[])(_VBUS_ARG PVDevice pVDev) = {
	fOsDiskFailed,
	fOsDiskFailed,
	fOsDiskFailed,
	fOsDiskFailed,
	fJBODMemberFailed,
	fRAID0MemberFailed,
	fRAID1MemberFailed,
	0,
	fRAID5MemberFailed,
};

