/***************************************************************************
 * File:         global.h
 * Description:  global header files
 *               DON'T modify this file for custom OS; modify osheader.h or
 *               OSxxx.h instead.
 * Copyright (c) 2000-2003 HighPoint Technologies, Inc. All rights reserved.
 ***************************************************************************/

#ifndef _GLOBAL_H_
#define _GLOBAL_H_

/***************************************************************************
 * include files
 ***************************************************************************/
#include "compiler.h"
#include "osheader.h"
#include "stypes.h"
#include "atapi.h"
#include "chip.h"
#include "channel.h"
#include "device.h"
#include "command.h"




#include "vdevice.h"

/* 
 * we don't want whole hptintf.h in shared code...
 * some constants must match that in hptintf.h!
 */
enum _driver_events_t
{	
	ET_DEVICE=0,
    ET_DEVICE_REMOVED,
    ET_DEVICE_PLUGGED,
    ET_DEVICE_ERROR,
    ET_REBUILD_STARTED,
    ET_REBUILD_ABORTED,
    ET_REBUILD_FINISHED,
    ET_SPARE_TOOK_OVER,
    ET_REBUILD_FAILED,
};

/***************************************************************************
 * Global Data
 ***************************************************************************/


extern VBus         gVBus[];
extern ChipInstance gChipInstances[];

extern PChannel  pChanStart;
extern PVDevice   pVDevStart;
extern char       *pDataPool;

#define pVDevEnd  ((PVDevice)pDataPool)
#define pChanEnd ((PChannel)pVDevStart)
#define pChipEnd  ((PChipInstance)pChanStart)

#endif
