/***************************************************************************
 * File:          hptchip.h
 * Description:   Definiation of HPT3XX IC
 * Copyright (c)  2000-2003 HighPoint Technologies, Inc. All rights reserved
 ***************************************************************************/


extern int pci_clock_mhz;

/***************************************************************************
 * HPT function & Macro
 ***************************************************************************/
#define HPT3XXPCIBASE 0x20

void InitHpt3xxChip(PChipInstance pChip, UINT reset);
void SetHpt3xxClk(PChipInstance pChip);
UCHAR fHpt3xxWaitOnBusy(PChannel pChan, UCHAR unit, int select);

void Hpt3xxModeSetting(PChannel pChan, PDevice pDevice, UCHAR NewMode);
UCHAR Hpt3xxControlIrq(PChipInstance pChip, UCHAR enable);

void fHptReset370IdeEngine(PChannel pChan, UCHAR UnitId);
void fHPT3xxCableDetect(PDevice pDev);
int fHPT370ClockCapable(PChannel pChan, int reading);
void fHPT370SwitchClock(PChannel pChan, int reading);
int fHPT3x2NClockCapable(PChannel pChan, int reading);
void fHPT3x2NSwitchClock(PChannel pChan, int reading);
BOOLEAN fHpt3xxFinishIntr(PDevice pDev);
void fHpt3xxResetController(PChannel pChan);



extern struct ChipProcTable hpt370_proc_table, hpt3xx_proc_table, hpt3x2n_proc_table;

/* product special code, implement in product dir */
#ifndef HPT3XX_IO_ENABLE
#define Hpt3xxIoEnable(pChip)
#else 
void Hpt3xxIoEnable(PChipInstance pChip);
#endif

#ifndef HPT3XX_SATA_RESET
#define Hpt3xxSataReset(pChan)
#else 
void Hpt3xxSataReset(PChannel pChan);
#endif

#define Hpt3xxCheckMaxMode(pChip)

